services:
 - docker:dind

variables:
 DOCKER_HOST: tcp://docker:2375
 DOCKER_DRIVER: overlay2

stages:
 - build
 - publish

build:
 image: maven:3-jdk-8
 stage: build
 script:
 - mvn clean install
 artifacts:
  paths:
   - tm-server/target/tm-server.jar
   - tm-client/target/tm-client.jar
   - tm-logger-consumer/target/tm-logger.jar
 only:
  - main

publish:
 image: docker
 stage: publish
 script:
  - docker login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker build -t $CI_REGISTRY_IMAGE/tm-server:latest tm-server/
  - docker push $CI_REGISTRY_IMAGE/tm-server:latest
  - docker build -t $CI_REGISTRY_IMAGE/tm-logger:latest tm-logger-consumer/
  - docker push $CI_REGISTRY_IMAGE/tm-logger:latest
  - docker build -t $CI_REGISTRY_IMAGE/tm-client:latest tm-client/
  - docker push $CI_REGISTRY_IMAGE/tm-client:latest
  - docker build -t $CI_REGISTRY_IMAGE/tm-balancer:latest tm-balancer/
  - docker push $CI_REGISTRY_IMAGE/tm-balancer:latest
 only:
  - main
